#!/usr/bin/perl
################################################
# HTTP Robot (by LWP module)
# Using: download.pl <servers_list> <search_strings_list> <path_to_store_html>
# Parameters
# <servers_list> - file with GET queryes. Token SSSS will be replaced with queris
# strings from <search_strings_list> file
# <search_strings_list> - file with queryes.
# <path_to_store_html> - Path to store html. Must exist.
# Ex: download.pl srv str www/
################################################

use LWP::UserAgent;
sub prn2log{
    print STDERR $_[0];
    print LOG $_[0];
}

#url encode data
sub escape {
#    shift() if ref($_[0]) || $_[0] eq $DefaultClass;
    my $toencode = shift;
    return undef unless defined($toencode);
    $toencode=~s/([^a-zA-Z0-9_.-])/uc sprintf("%%%02x",ord($1))/eg;
    $toencode=~s/%20/+/g;
    return $toencode;
}

$|=1;
unless (defined $ARGV[0]){die "No params 1";}
unless (defined $ARGV[1]){die "No params 2";}
unless (defined $ARGV[2]){die "No params 3";}

$base=$ARGV[2];

my ($file1, $file2)=($ARGV[0], $ARGV[1]);
open (F, $file1) || die "Can't open servers $file1: $!";
while(<F>){
    chomp;
    push @servers, $_;
}
close F;

open (F, $file2) || die "Can't open lists $file2: $!";
while(<F>){
    chomp;
    push @strs, $_;
}
close F;

$browser = new LWP::UserAgent;
$browser->agent("Falcon/32-Silver");

my ($i, $j, $saveto, $seekat);
for $i(@servers){
    for $j(0..$#strs){
	$srv_name = $i;
	$find_idx = $j;
	
	$srv_name =~ m#^http...(.*?)/#;
	$srv_name = $1;
	$saveto=$base."$srv_name-".sprintf("%02d",$find_idx).".htm";
	
	$find_str = escape($strs[$find_idx]);
	$seekat=$i;
	$seekat =~ s/^(.*)SSSS(.*)$/$1$find_str$2/;
	$urls{$seekat}=$saveto;
    }
}

open(LOG, ">>$base.log");

for $url(keys %urls){
    $file=$urls{$url};

    $webdoc = $browser->request(HTTP::Request->new(GET => $url));
    if($webdoc->is_success){
	prn2log "OK: $url ".$webdoc->title."\n";
	open(FILE, ">".$file);
	print FILE $webdoc->content;
#	print FILE $url;
	close (FILE);
    }else{
	prn2log "$0: Couldn't retrive $url\n";
    }
}

	open(FILE, ">".$base."done");
	close (FILE);

close(LOG);

